// THIS FILE IS AUTOMATICALLY GENERATED
// Add your code only between //--cg--xxxx-begin and //--cg--xxxx-end

//---------------------------------------------------------------------------
#pragma hdrstop
#pragma package(smart_init)

#include <stdio.h>
#include "stack.h"
#include "requestHandler.h"
#define FREE_Str(s) sqlite_freemem(s)

//--cg--sqlite--begin

//  include files and declarations here
#include <sqlite.h>
#include "methodName.h"
#include "threads.h"

// there is mutual exclusion for db access (sqlite_step).
TMutex sqliteMutex;
int    threadsIn = 0;
int    threadsWait = 0;
//--cg--sqlite--end

//---------------------------------------------------------------------------


PointerHolder* RequestHandler::getHolderByHandle(list<PointerHolder*> &v, int handle)
{
  list<PointerHolder*>::const_iterator iter;
  PointerHolder* ph = 0;
  for(iter=v.begin();iter != v.end();iter++)
  {
     ph = (*iter);
     if (ph->getHandle()==handle) return ph;
  }
  return ph;
}

 RequestHandler::RequestHandler()
 {
   handlecounter = 0;
 }

 RequestHandler::~RequestHandler()
 {

  list<PointerHolder*>::const_iterator iter;
  PointerHolder* ph = 0;

  for(iter=vmhandles.begin();iter != vmhandles.end();iter++)
  {
     ph = (*iter);
     sqlite_finalize((sqlite_vm*)ph->getPointer(),0);
     delete ph;
  }

  for(iter=dbhandles.begin();iter != dbhandles.end();iter++)
  {
     ph = (*iter);
     sqlite_close((sqlite*)ph->getPointer());
     delete ph;
  }

 }

//------------------------ svc methods -------------------------


int RequestHandler::svc_sqlite_open(
                  STACK_Str in_filename ,
                  STACK_Int in_mode 
                 ,  
                  STACK_Int *out_errcode ,
                  STACK_Str *out_errmsg ,
                  STACK_Int *out_db_handle 
             )
{
//--cg--sqlite/methods/sqlite_open--begin
 // implement this method
 try
 {
   sqlite* db = sqlite_open(in_filename,in_mode,out_errmsg);
   if (db != NULL)
   {
    PointerHolder* ph = new PointerHolder(db,handlecounter++);
    dbhandles.push_back(ph);
    (*out_db_handle) = ph->getHandle();
    (*out_errcode)   = SQLITE_OK;
     // printf("DB Handle created: Pool Size=%d\n",dbhandles.size());
   }
   else
   {
     (*out_errcode)  = SQLITE_ERROR;
   }
 }
 catch(...)
 {
  return SktStack::STACK_SERVER_STUB_ERROR;
 }
 return SktStack::STACK_OK;
//--cg--sqlite/methods/sqlite_open--end

}	


int RequestHandler::svc_sqlite_close(
                  STACK_Int in_db_handle 
             )
{
//--cg--sqlite/methods/sqlite_close--begin
 // implement this method
 PointerHolder *ph = getHolderByHandle(dbhandles,in_db_handle);
 if (ph != 0)
 {
  sqlite* db = (sqlite*)ph->getPointer();
  sqlite_close(db);
  dbhandles.remove(ph);
  delete ph;
  //printf("DB Handle released: Pool Size=%d\n",dbhandles.size());
  return SktStack::STACK_OK;
 }
 else
  return SktStack::STACK_USER_ERROR_BASE+BAD_HANDLE;
//--cg--sqlite/methods/sqlite_close--end

}	


int RequestHandler::svc_sqlite_compile(
                  STACK_Int in_db_handle ,
                  STACK_Str in_sql 
                 ,  
                  STACK_Int *out_tailIndex ,
                  STACK_Int *out_vm_handle ,
                  STACK_Int *out_errcode ,
                  STACK_Str *out_errmsg 
             )
{
//--cg--sqlite/methods/sqlite_compile--begin
 // implement this method
 PointerHolder *ph = getHolderByHandle(dbhandles,in_db_handle);
 if (ph != 0)
 {
   sqlite* db = (sqlite*)ph->getPointer();
   char* out_tail;

   sqlite_vm* vm;
  (*out_errcode) = sqlite_compile(db,in_sql,(const char **)&out_tail,&vm,out_errmsg);

     //DEBUG:
     printf("in_sql : %d\n",(unsigned int)in_sql);
     //         printf("in_sql length : %d\n",(int)st(in_sql));
     printf("out_tail : %d\n",(unsigned int)out_tail);
     (*out_tailIndex) = (unsigned int)(out_tail) - (unsigned int)in_sql + 1;
     printf("return tail index %d\n",*out_tailIndex);

   if ((*out_errcode) == SQLITE_OK)
   {
     PointerHolder *ph = new PointerHolder(vm,handlecounter++);
     vmhandles.push_back(ph);
     (*out_vm_handle) = ph->getHandle();
      //printf("VM Handle created: Pool Size=%d\n",vmhandles.size());
   }

  return SktStack::STACK_OK;
 }
 else
  return SktStack::STACK_USER_ERROR_BASE+BAD_HANDLE;

//--cg--sqlite/methods/sqlite_compile--end

}	


int RequestHandler::svc_sqlite_step(
                  STACK_Int in_vm_handle 
                 ,  
                  STACK_StrArray *out_colValues ,
                  STACK_StrArray *out_colNames ,
                  STACK_Int *out_errcode 
             )
{
//--cg--sqlite/methods/sqlite_step--begin
 // implement this method
 PointerHolder *ph = getHolderByHandle(vmhandles,in_vm_handle);
 if (ph != 0)
 {
   sqlite_vm* vm = (sqlite_vm*)ph->getPointer();

   sqliteMutex.lock();
    (*out_errcode) = sqlite_step(vm,&(out_colNames->len), (const char ***)&(out_colValues->items), (const char ***)&(out_colNames->items));
   sqliteMutex.unlock();
   
   if (*out_errcode == SQLITE_ROW)
   {
      out_colValues->len = out_colNames->len;
   }
   else
   if (*out_errcode == SQLITE_DONE)
   {
     out_colValues->len = 0;
   }
   else 
   if (*out_errcode == SQLITE_BUSY)
   {
     printf("SQLITE IS BUSY\n");
     out_colValues->len = 0;
     out_colNames->len = 0;
   }
   else  
   {
     out_colValues->len = 0;
     out_colNames->len = 0;
   }

  return SktStack::STACK_OK;
 }
 else
  return SktStack::STACK_USER_ERROR_BASE+BAD_HANDLE;
//--cg--sqlite/methods/sqlite_step--end

}	


int RequestHandler::svc_sqlite_finalize(
                  STACK_Int in_vm_handle 
                 ,  
                  STACK_Int *out_errcode ,
                  STACK_Str *out_errmsg 
             )
{
//--cg--sqlite/methods/sqlite_finalize--begin

 PointerHolder *ph = getHolderByHandle(vmhandles,in_vm_handle);
 if (ph != 0)
 {
   sqlite_vm* vm = (sqlite_vm*)ph->getPointer();
   (*out_errmsg)  = 0;
   (*out_errcode) = sqlite_finalize(vm,out_errmsg);
   vmhandles.remove(ph);
   delete ph;
   //printf("VM Handle released: Pool Size=%d\n",vmhandles.size());
   return SktStack::STACK_OK;
 }
 else
  return SktStack::STACK_USER_ERROR_BASE+BAD_HANDLE;

//--cg--sqlite/methods/sqlite_finalize--end

}	


int RequestHandler::svc_sqlite_reset(
                  STACK_Int in_vm_handle 
                 ,  
                  STACK_Int *out_errcode ,
                  STACK_Str *out_errmsg 
             )
{
//--cg--sqlite/methods/sqlite_reset--begin

 PointerHolder *ph = getHolderByHandle(vmhandles,in_vm_handle);
 if (ph != 0)
 {
   sqlite_vm* vm = (sqlite_vm*)ph->getPointer();
   (*out_errcode) = sqlite_reset(vm,out_errmsg);
   return SktStack::STACK_OK;
 }
 else
  return SktStack::STACK_USER_ERROR_BASE+BAD_HANDLE;
//--cg--sqlite/methods/sqlite_reset--end

}	


int RequestHandler::svc_sqlite_changes(
                  STACK_Int in_db_handle 
                 ,  
                  STACK_Int *out_count 
             )
{
//--cg--sqlite/methods/sqlite_changes--begin

 PointerHolder *ph = getHolderByHandle(dbhandles,in_db_handle);
 if (ph != 0)
 {
   sqlite* db = (sqlite*)ph->getPointer();
   (*out_count) = sqlite_changes(db);
   return SktStack::STACK_OK;
 }
 else
  return SktStack::STACK_USER_ERROR_BASE+BAD_HANDLE;
//--cg--sqlite/methods/sqlite_changes--end

}	


int RequestHandler::svc_sqlite_last_insert_rowid(
                  STACK_Int in_db_handle 
                 ,  
                  STACK_Int *out_rowid 
             )
{
//--cg--sqlite/methods/sqlite_last_insert_rowid--begin
 PointerHolder *ph = getHolderByHandle(dbhandles,in_db_handle);
 if (ph != 0)
 {
   sqlite* db = (sqlite*)ph->getPointer();
   (*out_rowid) = sqlite_last_insert_rowid(db);
   return SktStack::STACK_OK;
 }
 else
  return SktStack::STACK_USER_ERROR_BASE+BAD_HANDLE;
//--cg--sqlite/methods/sqlite_last_insert_rowid--end

}	


int RequestHandler::svc_sqlite_interrupt(
                  STACK_Int in_db_handle 
             )
{
//--cg--sqlite/methods/sqlite_interrupt--begin
 PointerHolder *ph = getHolderByHandle(dbhandles,in_db_handle);
 if (ph != 0)
 {
   sqlite* db = (sqlite*)ph->getPointer();
   sqlite_interrupt(db);
   return SktStack::STACK_OK;
 }
 else
  return SktStack::STACK_USER_ERROR_BASE+BAD_HANDLE;
//--cg--sqlite/methods/sqlite_interrupt--end

}	


int RequestHandler::svc_sqlite_libversion(
                   
                  STACK_Str *out_version 
             )
{
//--cg--sqlite/methods/sqlite_libversion--begin
 (*out_version) = (char*)sqlite_libversion();
 return SktStack::STACK_OK;
//--cg--sqlite/methods/sqlite_libversion--end

}	


int RequestHandler::svc_sqlite_libencoding(
                   
                  STACK_Str *out_encoding 
             )
{
//--cg--sqlite/methods/sqlite_libencoding--begin
 (*out_encoding) = (char*)sqlite_libencoding();
 return SktStack::STACK_OK;	
//--cg--sqlite/methods/sqlite_libencoding--end

}	


//! automatically generated method (from methods.def)
int RequestHandler::handleRequest(int new_socket, SktStack *stack)
{
    int res = stack->recvMessage(new_socket);
    if (res == SktStack::STACK_OK)
    {
      char Method = stack->readByte();
      try
      {
          switch (MethodName(Method))
          {
            case METHOD_None:
                 {
                   stack->reset();
                   stack->writeInt(SktStack::STACK_OK);
                 }
                 break;
            case METHOD_sqlite_open:
               {
                    // read input parameters
                    STACK_Str in_filename = stack->readStr();
                    STACK_Int in_mode = stack->readInt();

                    //defining output parameters
                    STACK_Int out_errcode;
                    STACK_Str out_errmsg;
                    STACK_Int out_db_handle;

                    // call method
                    int res = svc_sqlite_open(
                      in_filename ,
                      in_mode 
                     ,  
                      &out_errcode ,
                      &out_errmsg ,
                      &out_db_handle 
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);

                    // write back output parameters
                    if (res == SktStack::STACK_OK)
                    {
                       stack->writeInt(out_errcode);
                       stack->writeStr(out_errmsg);
                       //freeing because this param is realloced
                       FREE_Str(out_errmsg);
                       stack->writeInt(out_db_handle);
                    } 	 
               } // end of case METHOD_sqlite_open:
               break;
            case METHOD_sqlite_close:
               {
                    // read input parameters
                    STACK_Int in_db_handle = stack->readInt();


                    // call method
                    int res = svc_sqlite_close(
                      in_db_handle 
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);

               } // end of case METHOD_sqlite_close:
               break;
            case METHOD_sqlite_compile:
               {
                    // read input parameters
                    STACK_Int in_db_handle = stack->readInt();
                    STACK_Str in_sql = stack->readStr();

                    //defining output parameters
                    STACK_Int out_tailIndex;
                    STACK_Int out_vm_handle;
                    STACK_Int out_errcode;
                    STACK_Str out_errmsg;

                    // call method
                    int res = svc_sqlite_compile(
                      in_db_handle ,
                      in_sql 
                     ,  
                      &out_tailIndex ,
                      &out_vm_handle ,
                      &out_errcode ,
                      &out_errmsg 
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);

                    // write back output parameters
                    if (res == SktStack::STACK_OK)
                    {
                       stack->writeInt(out_tailIndex);
                       stack->writeInt(out_vm_handle);
                       stack->writeInt(out_errcode);
                       stack->writeStr(out_errmsg);
                       //freeing because this param is realloced
                       FREE_Str(out_errmsg);
                    } 	 
               } // end of case METHOD_sqlite_compile:
               break;
            case METHOD_sqlite_step:
               {
                    // read input parameters
                    STACK_Int in_vm_handle = stack->readInt();

                    //defining output parameters
                    STACK_StrArray out_colValues;
                    STACK_StrArray out_colNames;
                    STACK_Int out_errcode;

                    // call method
                    int res = svc_sqlite_step(
                      in_vm_handle 
                     ,  
                      &out_colValues ,
                      &out_colNames ,
                      &out_errcode 
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);

                    // write back output parameters
                    if (res == SktStack::STACK_OK)
                    {
                       stack->writeStrArray(out_colValues);
                       stack->writeStrArray(out_colNames);
                       stack->writeInt(out_errcode);
                    } 	 
               } // end of case METHOD_sqlite_step:
               break;
            case METHOD_sqlite_finalize:
               {
                    // read input parameters
                    STACK_Int in_vm_handle = stack->readInt();

                    //defining output parameters
                    STACK_Int out_errcode;
                    STACK_Str out_errmsg;

                    // call method
                    int res = svc_sqlite_finalize(
                      in_vm_handle 
                     ,  
                      &out_errcode ,
                      &out_errmsg 
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);

                    // write back output parameters
                    if (res == SktStack::STACK_OK)
                    {
                       stack->writeInt(out_errcode);
                       stack->writeStr(out_errmsg);
                       //freeing because this param is realloced
                       FREE_Str(out_errmsg);
                    } 	 
               } // end of case METHOD_sqlite_finalize:
               break;
            case METHOD_sqlite_reset:
               {
                    // read input parameters
                    STACK_Int in_vm_handle = stack->readInt();

                    //defining output parameters
                    STACK_Int out_errcode;
                    STACK_Str out_errmsg;

                    // call method
                    int res = svc_sqlite_reset(
                      in_vm_handle 
                     ,  
                      &out_errcode ,
                      &out_errmsg 
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);

                    // write back output parameters
                    if (res == SktStack::STACK_OK)
                    {
                       stack->writeInt(out_errcode);
                       stack->writeStr(out_errmsg);
                       //freeing because this param is realloced
                       FREE_Str(out_errmsg);
                    } 	 
               } // end of case METHOD_sqlite_reset:
               break;
            case METHOD_sqlite_changes:
               {
                    // read input parameters
                    STACK_Int in_db_handle = stack->readInt();

                    //defining output parameters
                    STACK_Int out_count;

                    // call method
                    int res = svc_sqlite_changes(
                      in_db_handle 
                     ,  
                      &out_count 
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);

                    // write back output parameters
                    if (res == SktStack::STACK_OK)
                    {
                       stack->writeInt(out_count);
                    } 	 
               } // end of case METHOD_sqlite_changes:
               break;
            case METHOD_sqlite_last_insert_rowid:
               {
                    // read input parameters
                    STACK_Int in_db_handle = stack->readInt();

                    //defining output parameters
                    STACK_Int out_rowid;

                    // call method
                    int res = svc_sqlite_last_insert_rowid(
                      in_db_handle 
                     ,  
                      &out_rowid 
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);

                    // write back output parameters
                    if (res == SktStack::STACK_OK)
                    {
                       stack->writeInt(out_rowid);
                    } 	 
               } // end of case METHOD_sqlite_last_insert_rowid:
               break;
            case METHOD_sqlite_interrupt:
               {
                    // read input parameters
                    STACK_Int in_db_handle = stack->readInt();


                    // call method
                    int res = svc_sqlite_interrupt(
                      in_db_handle 
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);

               } // end of case METHOD_sqlite_interrupt:
               break;
            case METHOD_sqlite_libversion:
               {

                    //defining output parameters
                    STACK_Str out_version;

                    // call method
                    int res = svc_sqlite_libversion(
                       
                      &out_version 
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);

                    // write back output parameters
                    if (res == SktStack::STACK_OK)
                    {
                       stack->writeStr(out_version);
                    } 	 
               } // end of case METHOD_sqlite_libversion:
               break;
            case METHOD_sqlite_libencoding:
               {

                    //defining output parameters
                    STACK_Str out_encoding;

                    // call method
                    int res = svc_sqlite_libencoding(
                       
                      &out_encoding 
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);

                    // write back output parameters
                    if (res == SktStack::STACK_OK)
                    {
                       stack->writeStr(out_encoding);
                    } 	 
               } // end of case METHOD_sqlite_libencoding:
               break;
            default:
              return SktStack::STACK_WRONG_FORMAT_OR_TOO_BIG;
          } // end of case
       } // end of try
       catch(...)
       {
           // something went wrong
           stack->reset();
           stack->writeInt(SktStack::STACK_SERVER_STUB_ERROR);
       }
  }
  else
  {
    //message  broken. Try to send error back
    return res;
  }
  // send and return
  return stack->sendMessage(new_socket);
}







