//---------------------------------------------------------------------------

#ifndef stackH
#define stackH
//---------------------------------------------------------------------------


#include "stream.h"

typedef unsigned char STACK_Byte;

typedef char* STACK_Str;

typedef struct
          {
            int len;
            STACK_Str* items;
          } STACK_StrArray;

typedef int STACK_Int;


class SktStack : public SktStream
{
private:
   int toGet;
   int HEADER_SIZE;
protected:
   int sockfd;
   void *sock_addr;
   int sock_addr_length;
   SktStream* header;
public:
   static const int STACK_OK = 0;
   static const int STACK_SEND_ERROR = 1;
   static const int STACK_RECV_HEADER_ERROR = 2;
   static const int STACK_RECV_BODY_ERROR = 3;
   static const int STACK_ACCEPT_ERROR = 4;
   static const int STACK_CONNECT_ERROR = 5;
   static const int STACK_WRONG_FORMAT_OR_TOO_BIG = 6;
   static const int STACK_SERVER_STUB_ERROR = 7;
   static const int STACK_USER_ERROR_BASE = 1000;


   static const int STACK_MAX_SIZE = 1024*1024; // 1MB

   static const char* errorMessage(int err);
   
   int invoke(int sock);

   int socket() { return sockfd; }
   void insertHeader();
   int sendMessageBuffer(int sock);
   void readHeader();
   int recvMessage(int sock);
   int sendMessage(int sock);

   STACK_StrArray readStrArray();
   void writeStrArray(const STACK_StrArray& strArray);

   SktStack();
   ~SktStack();
};

#endif
